
#include <stdio.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */
#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <errno.h>   /* Error number definitions */
#include <termios.h> /* POSIX terminal control definitions */



int fd;

int initport(int fd) {
	struct termios options;
	// Get the current options for the port...
	tcgetattr(fd, &options);
	// Set the baud rates to 38400...
	cfsetispeed(&options, B38400);
	cfsetospeed(&options, B38400);
	// Enable the receiver and set local mode...
	options.c_cflag |= (CLOCAL | CREAD);
	options.c_cflag &= ~PARENB;
	options.c_cflag &= ~CSTOPB;
	//options.c_cflag |= CSTOPB;
	options.c_cflag &= ~CSIZE;
	options.c_cflag |= CS8;

	// Set the new options for the port...
	tcsetattr(fd, TCSANOW, &options);
	return 1;
}


int writeport(int fd, char *chars) {
	int len = strlen(chars);
	chars[len] = 0x0d; // stick a <CR> after the command
  	chars[len+1] = 0x00; // terminate the string properly
	int n = write(fd, chars, strlen(chars));
	//printf("n for write:0x%x\n", n);
	printf("lenght:0x%x\n", len);
	if (n < 0) {
		fputs("write failed!\n", stderr);
		return 0;
	}
	return 1;
}

int getbaud(int fd) {
	struct termios termAttr;
	int inputSpeed = -1;
	speed_t baudRate;
	tcgetattr(fd, &termAttr);
	/* Get the input speed.                              */
	baudRate = cfgetispeed(&termAttr);
	switch (baudRate) {
		case B0:      inputSpeed = 0; break;
		case B50:     inputSpeed = 50; break;
		case B110:    inputSpeed = 110; break;
		case B134:    inputSpeed = 134; break;
		case B150:    inputSpeed = 150; break;
		case B200:    inputSpeed = 200; break;
		case B300:    inputSpeed = 300; break;
		case B600:    inputSpeed = 600; break;
		case B1200:   inputSpeed = 1200; break;
		case B1800:   inputSpeed = 1800; break;
		case B2400:   inputSpeed = 2400; break;
		case B4800:   inputSpeed = 4800; break;
		case B9600:   inputSpeed = 9600; break;
		case B19200:  inputSpeed = 19200; break;
		case B38400:  inputSpeed = 38400; break;
	}
	return inputSpeed;
}


int main(int argc, char *argv[]){
// 	int i=0;

fd = open("/dev/ttyS1", O_RDWR | O_NOCTTY | O_NDELAY);


	if (fd == -1) {
		perror("open_port: Unable to open /dev/ttyS1 - ");
		return 1;
	} else {
		fcntl(fd, F_SETFL, 0);
	}
	
	printf("baud=%d\n", getbaud(fd));
	initport(fd);
	printf("baud=%d\n", getbaud(fd));

	char sCmd[254]; 
	char sCmd1[254]; 
	
	strcpy( sCmd,"SEND 1 84 FF 0 0 1 1" );
	strcpy( sCmd1,"RECV 1 03 FF 1 0 8 0" );
	
	
	 if (!writeport(fd, sCmd)) {
		printf("write failed\n");
		close(fd);
		return 1;
	}
	printf("written:%s\n", sCmd);
	
	usleep(500000);
	if (!writeport(fd, sCmd1)) {
		printf("write failed\n");
		close(fd);
		return 1;
	}
	printf("written:%s\n", sCmd1);
	//close(fd);
	return 0;


}